#!/bin/sh

abort() {
	echo "$*"
	exit 1
}

if [ -z "$2" -o -n "$3" ]; then
	echo "Usage: $0 <version> <tag>"
	exit 2
fi

[ -d "boxi-$1" ] && abort "boxi-$1 already exists"

cvs -d /home/cvs/root co -r $2 -d boxi-$1 boxi \
|| abort "Failed to check out $2 from repository"

cd boxi-$1 || abort "version directory missing"

NOCONFIGURE=1 ./autogen.sh || abort "autogen.sh failed"
pod2html README.pod -t "Boxi README" > README.html
pod2text README.pod                  > README.txt

cd ..
tar czvf boxi-$1.tar.gz boxi-$1 || abort "creating tarball failed"
rm -rf boxi-$1 || abort "deleting old directory boxi-$1 failed"
